/* A Bison parser, made by GNU Bison 2.1.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Using locations.  */
#define YYLSP_NEEDED 1

/* Substitute the variable and function names.  */
#define yyparse ael_yyparse
#define yylex   ael_yylex
#define yyerror ael_yyerror
#define yylval  ael_yylval
#define yychar  ael_yychar
#define yydebug ael_yydebug
#define yynerrs ael_yynerrs
#define yylloc ael_yylloc

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     KW_CONTEXT = 258,
     LC = 259,
     RC = 260,
     LP = 261,
     RP = 262,
     SEMI = 263,
     EQ = 264,
     COMMA = 265,
     COLON = 266,
     AMPER = 267,
     BAR = 268,
     AT = 269,
     KW_MACRO = 270,
     KW_GLOBALS = 271,
     KW_IGNOREPAT = 272,
     KW_SWITCH = 273,
     KW_IF = 274,
     KW_IFTIME = 275,
     KW_ELSE = 276,
     KW_RANDOM = 277,
     KW_ABSTRACT = 278,
     EXTENMARK = 279,
     KW_GOTO = 280,
     KW_JUMP = 281,
     KW_RETURN = 282,
     KW_BREAK = 283,
     KW_CONTINUE = 284,
     KW_REGEXTEN = 285,
     KW_HINT = 286,
     KW_FOR = 287,
     KW_WHILE = 288,
     KW_CASE = 289,
     KW_PATTERN = 290,
     KW_DEFAULT = 291,
     KW_CATCH = 292,
     KW_SWITCHES = 293,
     KW_ESWITCHES = 294,
     KW_INCLUDES = 295,
     word = 296
   };
#endif
/* Tokens.  */
#define KW_CONTEXT 258
#define LC 259
#define RC 260
#define LP 261
#define RP 262
#define SEMI 263
#define EQ 264
#define COMMA 265
#define COLON 266
#define AMPER 267
#define BAR 268
#define AT 269
#define KW_MACRO 270
#define KW_GLOBALS 271
#define KW_IGNOREPAT 272
#define KW_SWITCH 273
#define KW_IF 274
#define KW_IFTIME 275
#define KW_ELSE 276
#define KW_RANDOM 277
#define KW_ABSTRACT 278
#define EXTENMARK 279
#define KW_GOTO 280
#define KW_JUMP 281
#define KW_RETURN 282
#define KW_BREAK 283
#define KW_CONTINUE 284
#define KW_REGEXTEN 285
#define KW_HINT 286
#define KW_FOR 287
#define KW_WHILE 288
#define KW_CASE 289
#define KW_PATTERN 290
#define KW_DEFAULT 291
#define KW_CATCH 292
#define KW_SWITCHES 293
#define KW_ESWITCHES 294
#define KW_INCLUDES 295
#define word 296




/* Copy the first part of user declarations.  */
#line 1 "ael.y"

/*
 * Asterisk -- An open source telephony toolkit. 
 *
 * Copyright (C) 2006, Digium, Inc.
 *
 * Steve Murphy <murf@parsetree.com>
 *
 * See http://www.asterisk.org for more information about
 * the Asterisk project. Please do not directly contact
 * any of the maintainers of this project for assistance;
 * the project provides a web site, mailing lists and IRC
 * channels for your use.
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License Version 2. See the LICENSE file
 * at the top of the source tree.
 */
/*! \file
 *
 * \brief Bison Grammar description of AEL2.
 * 
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "asterisk/logger.h"
#include "asterisk/ael_structs.h"

extern void reset_parencount(yyscan_t yyscanner);
extern void reset_semicount(yyscan_t yyscanner);
extern void reset_argcount(yyscan_t yyscanner );

#define YYPARSE_PARAM parseio
#define YYLEX_PARAM ((struct parse_io *)parseio)->scanner
#define YYERROR_VERBOSE 1

/* this stuff is included so I can declare the proto for yyerror */ 
#if ! defined (YYLTYPE) && ! defined (YYLTYPE_IS_DECLARED)
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif
#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
typedef union YYSTYPE {
	char *str;
	struct pval *pval;
} YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif

int ael_errcnt = 0;
extern char *my_file;
void yyerror(YYLTYPE *locp,void *nothing, char const *s);
int ael_yylex (YYSTYPE * yylval_param, YYLTYPE * yylloc_param , void * yyscanner);
int ael_is_funcname(char *name);
 static char *ael_token_subst(char *mess);
 extern char *prev_word;
 


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 72 "ael.y"
typedef union YYSTYPE {
	char *str;
	struct pval *pval;
} YYSTYPE;
/* Line 196 of yacc.c.  */
#line 250 "ael.tab.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif

#if ! defined (YYLTYPE) && ! defined (YYLTYPE_IS_DECLARED)
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */


/* Line 219 of yacc.c.  */
#line 274 "ael.tab.c"

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T) && (defined (__STDC__) || defined (__cplusplus))
# include <stddef.h> /* INFRINGES ON USER NAME SPACE */
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if defined (__STDC__) || defined (__cplusplus)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     define YYINCLUDED_STDLIB_H
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2005 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM ((YYSIZE_T) -1)
#  endif
#  ifdef __cplusplus
extern "C" {
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if (! defined (malloc) && ! defined (YYINCLUDED_STDLIB_H) \
	&& (defined (__STDC__) || defined (__cplusplus)))
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if (! defined (free) && ! defined (YYINCLUDED_STDLIB_H) \
	&& (defined (__STDC__) || defined (__cplusplus)))
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifdef __cplusplus
}
#  endif
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYLTYPE_IS_TRIVIAL) && YYLTYPE_IS_TRIVIAL \
             && defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
    YYLTYPE yyls;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  17
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   565

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  42
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  51
/* YYNRULES -- Number of rules. */
#define YYNRULES  143
/* YYNRULES -- Number of states. */
#define YYNSTATES  339

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   296

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short int yyprhs[] =
{
       0,     0,     3,     5,     7,    10,    13,    15,    17,    19,
      21,    27,    32,    38,    43,    50,    56,    63,    69,    78,
      86,    94,   101,   106,   110,   112,   115,   118,   119,   125,
     127,   131,   134,   136,   139,   142,   144,   146,   148,   150,
     152,   153,   159,   161,   166,   170,   175,   183,   192,   194,
     197,   200,   201,   207,   208,   214,   229,   240,   242,   245,
     247,   250,   254,   255,   262,   266,   267,   273,   277,   281,
     284,   285,   286,   287,   300,   301,   308,   311,   315,   319,
     322,   325,   326,   332,   335,   338,   341,   344,   349,   352,
     357,   360,   365,   367,   369,   373,   379,   385,   387,   391,
     397,   401,   407,   411,   412,   418,   422,   423,   427,   431,
     434,   436,   437,   441,   444,   446,   449,   454,   458,   463,
     467,   470,   474,   476,   479,   481,   487,   492,   496,   501,
     505,   508,   512,   515,   518,   533,   544,   548,   564,   576,
     579,   581,   583,   588
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      43,     0,    -1,    44,    -1,    45,    -1,    44,    45,    -1,
      44,     1,    -1,    46,    -1,    47,    -1,    48,    -1,     8,
      -1,     3,    41,     4,    53,     5,    -1,     3,    41,     4,
       5,    -1,     3,    36,     4,    53,     5,    -1,     3,    36,
       4,     5,    -1,    23,     3,    41,     4,    53,     5,    -1,
      23,     3,    41,     4,     5,    -1,    23,     3,    36,     4,
      53,     5,    -1,    23,     3,    36,     4,     5,    -1,    15,
      41,     6,    52,     7,     4,    85,     5,    -1,    15,    41,
       6,    52,     7,     4,     5,    -1,    15,    41,     6,     7,
       4,    85,     5,    -1,    15,    41,     6,     7,     4,     5,
      -1,    16,     4,    49,     5,    -1,    16,     4,     5,    -1,
      50,    -1,    49,    50,    -1,    49,     1,    -1,    -1,    41,
       9,    51,    41,     8,    -1,    41,    -1,    52,    10,    41,
      -1,    52,     1,    -1,    54,    -1,    53,    54,    -1,    53,
       1,    -1,    57,    -1,    92,    -1,    87,    -1,    88,    -1,
      56,    -1,    -1,    41,     9,    55,    41,     8,    -1,     8,
      -1,    17,    24,    41,     8,    -1,    41,    24,    68,    -1,
      30,    41,    24,    68,    -1,    31,     6,    65,     7,    41,
      24,    68,    -1,    30,    31,     6,    65,     7,    41,    24,
      68,    -1,    68,    -1,    58,    68,    -1,    58,     1,    -1,
      -1,    19,     6,    60,    64,     7,    -1,    -1,    22,     6,
      62,    64,     7,    -1,    20,     6,    65,    11,    65,    11,
      65,    13,    65,    13,    65,    13,    65,     7,    -1,    20,
       6,    41,    13,    65,    13,    65,    13,    65,     7,    -1,
      41,    -1,    41,    41,    -1,    41,    -1,    41,    41,    -1,
      41,    41,    41,    -1,    -1,    18,     6,    67,    41,     7,
       4,    -1,     4,    58,     5,    -1,    -1,    41,     9,    69,
      41,     8,    -1,    25,    75,     8,    -1,    26,    76,     8,
      -1,    41,    11,    -1,    -1,    -1,    -1,    32,     6,    70,
      41,     8,    71,    41,     8,    72,    41,     7,    68,    -1,
      -1,    33,     6,    73,    41,     7,    68,    -1,    66,     5,
      -1,    66,    83,     5,    -1,    12,    77,     8,    -1,    81,
       8,    -1,    41,     8,    -1,    -1,    81,     9,    74,    41,
       8,    -1,    28,     8,    -1,    27,     8,    -1,    29,     8,
      -1,    61,    68,    -1,    61,    68,    21,    68,    -1,    59,
      68,    -1,    59,    68,    21,    68,    -1,    63,    68,    -1,
      63,    68,    21,    68,    -1,     8,    -1,    41,    -1,    41,
      13,    41,    -1,    41,    13,    41,    13,    41,    -1,    36,
      13,    41,    13,    41,    -1,    41,    -1,    41,    10,    41,
      -1,    41,    10,    41,    14,    41,    -1,    41,    14,    41,
      -1,    41,    10,    41,    14,    36,    -1,    41,    14,    36,
      -1,    -1,    41,     6,    78,    82,     7,    -1,    41,     6,
       7,    -1,    -1,    41,    80,     6,    -1,    79,    82,     7,
      -1,    79,     7,    -1,    64,    -1,    -1,    82,    10,    41,
      -1,    82,    10,    -1,    84,    -1,    83,    84,    -1,    34,
      41,    11,    58,    -1,    36,    11,    58,    -1,    35,    41,
      11,    58,    -1,    34,    41,    11,    -1,    36,    11,    -1,
      35,    41,    11,    -1,    86,    -1,    85,    86,    -1,    68,
      -1,    37,    41,     4,    58,     5,    -1,    38,     4,    89,
       5,    -1,    38,     4,     5,    -1,    39,     4,    89,     5,
      -1,    39,     4,     5,    -1,    41,     8,    -1,    89,    41,
       8,    -1,    89,     1,    -1,    91,     8,    -1,    91,    13,
      65,    11,    65,    11,    65,    13,    65,    13,    65,    13,
      65,     8,    -1,    91,    13,    41,    13,    65,    13,    65,
      13,    65,     8,    -1,    90,    91,     8,    -1,    90,    91,
      13,    65,    11,    65,    11,    65,    13,    65,    13,    65,
      13,    65,     8,    -1,    90,    91,    13,    41,    13,    65,
      13,    65,    13,    65,     8,    -1,    90,     1,    -1,    41,
      -1,    36,    -1,    40,     4,    90,     5,    -1,    40,     4,
       5,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,   139,   139,   142,   143,   146,   149,   150,   151,   152,
     155,   156,   157,   158,   159,   160,   161,   162,   165,   167,
     168,   169,   172,   173,   176,   177,   178,   181,   181,   184,
     185,   186,   189,   190,   193,   196,   197,   198,   199,   200,
     201,   201,   202,   205,   208,   209,   210,   211,   215,   216,
     219,   222,   222,   225,   225,   228,   247,   266,   267,   269,
     270,   271,   274,   274,   279,   280,   280,   283,   284,   285,
     286,   287,   288,   286,   291,   291,   294,   295,   296,   297,
     298,   300,   300,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   344,   345,   348,   353,   360,   363,   366,
     371,   376,   381,   388,   388,   391,   394,   394,   402,   408,
     411,   412,   413,   414,   417,   418,   423,   424,   425,   426,
     427,   428,   431,   432,   437,   438,   441,   442,   445,   446,
     449,   450,   451,   454,   455,   476,   489,   490,   510,   523,
     526,   527,   530,   531
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "KW_CONTEXT", "LC", "RC", "LP", "RP",
  "SEMI", "EQ", "COMMA", "COLON", "AMPER", "BAR", "AT", "KW_MACRO",
  "KW_GLOBALS", "KW_IGNOREPAT", "KW_SWITCH", "KW_IF", "KW_IFTIME",
  "KW_ELSE", "KW_RANDOM", "KW_ABSTRACT", "EXTENMARK", "KW_GOTO", "KW_JUMP",
  "KW_RETURN", "KW_BREAK", "KW_CONTINUE", "KW_REGEXTEN", "KW_HINT",
  "KW_FOR", "KW_WHILE", "KW_CASE", "KW_PATTERN", "KW_DEFAULT", "KW_CATCH",
  "KW_SWITCHES", "KW_ESWITCHES", "KW_INCLUDES", "word", "$accept", "file",
  "objects", "object", "context", "macro", "globals", "global_statements",
  "global_statement", "@1", "arglist", "elements", "element", "@2",
  "ignorepat", "extension", "statements", "if_head", "@3", "random_head",
  "@4", "iftime_head", "word_list", "word3_list", "switch_head", "@5",
  "statement", "@6", "@7", "@8", "@9", "@10", "@11", "target",
  "jumptarget", "macro_call", "@12", "application_call_head", "@13",
  "application_call", "eval_arglist", "case_statements", "case_statement",
  "macro_statements", "macro_statement", "switches", "eswitches",
  "switchlist", "includeslist", "includedname", "includes", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    42,    43,    44,    44,    44,    45,    45,    45,    45,
      46,    46,    46,    46,    46,    46,    46,    46,    47,    47,
      47,    47,    48,    48,    49,    49,    49,    51,    50,    52,
      52,    52,    53,    53,    53,    54,    54,    54,    54,    54,
      55,    54,    54,    56,    57,    57,    57,    57,    58,    58,
      58,    60,    59,    62,    61,    63,    63,    64,    64,    65,
      65,    65,    67,    66,    68,    69,    68,    68,    68,    68,
      70,    71,    72,    68,    73,    68,    68,    68,    68,    68,
      68,    74,    68,    68,    68,    68,    68,    68,    68,    68,
      68,    68,    68,    75,    75,    75,    75,    76,    76,    76,
      76,    76,    76,    78,    77,    77,    80,    79,    81,    81,
      82,    82,    82,    82,    83,    83,    84,    84,    84,    84,
      84,    84,    85,    85,    86,    86,    87,    87,    88,    88,
      89,    89,    89,    90,    90,    90,    90,    90,    90,    90,
      91,    91,    92,    92
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     1,     2,     2,     1,     1,     1,     1,
       5,     4,     5,     4,     6,     5,     6,     5,     8,     7,
       7,     6,     4,     3,     1,     2,     2,     0,     5,     1,
       3,     2,     1,     2,     2,     1,     1,     1,     1,     1,
       0,     5,     1,     4,     3,     4,     7,     8,     1,     2,
       2,     0,     5,     0,     5,    14,    10,     1,     2,     1,
       2,     3,     0,     6,     3,     0,     5,     3,     3,     2,
       0,     0,     0,    12,     0,     6,     2,     3,     3,     2,
       2,     0,     5,     2,     2,     2,     2,     4,     2,     4,
       2,     4,     1,     1,     3,     5,     5,     1,     3,     5,
       3,     5,     3,     0,     5,     3,     0,     3,     3,     2,
       1,     0,     3,     2,     1,     2,     4,     3,     4,     3,
       2,     3,     1,     2,     1,     5,     4,     3,     4,     3,
       2,     3,     2,     2,    14,    10,     3,    15,    11,     2,
       1,     1,     4,     3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     0,     9,     0,     0,     0,     0,     0,     3,     6,
       7,     8,     0,     0,     0,     0,     0,     1,     5,     4,
       0,     0,     0,    23,     0,     0,    24,     0,     0,    13,
      42,     0,     0,     0,     0,     0,     0,     0,     0,    32,
      39,    35,    37,    38,    36,    11,     0,     0,    29,     0,
      27,    26,    22,    25,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    40,     0,    34,    12,    33,    10,     0,
      31,     0,     0,     0,    17,     0,    15,     0,     0,     0,
       0,    59,     0,   127,     0,     0,   129,     0,   143,   141,
     140,     0,     0,     0,     0,    92,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   106,     0,
       0,     0,     0,    44,   111,     0,    21,     0,   124,     0,
     122,     0,    30,     0,    16,    14,    43,     0,    45,    60,
       0,   130,   132,   126,     0,   128,   139,   142,     0,   133,
       0,     0,     0,    48,     0,     0,    62,    51,     0,    53,
       0,    93,     0,    97,     0,    84,    83,    85,    70,    74,
      80,    65,    69,     0,    88,    86,    90,    76,     0,     0,
       0,     0,   114,   109,    57,   110,     0,    79,    81,     0,
      20,   123,    19,     0,    28,     0,    61,     0,   131,   136,
       0,    59,     0,    41,    50,    64,    49,   103,    78,     0,
       0,    59,     0,     0,     0,     0,    67,     0,     0,    68,
       0,     0,     0,   107,     0,     0,     0,     0,     0,   120,
      77,   115,    58,   108,   113,     0,     0,    18,     0,     0,
      59,     0,     0,     0,   105,   111,     0,     0,     0,     0,
       0,     0,    94,    98,   102,   100,     0,     0,     0,    89,
      87,    91,   119,   121,     0,   112,     0,     0,     0,    46,
       0,     0,     0,     0,     0,     0,    52,     0,     0,    54,
       0,     0,     0,    71,     0,    66,     0,     0,    82,   125,
      47,     0,     0,     0,     0,   104,    63,     0,     0,    96,
      95,   101,    99,     0,    75,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    72,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   135,     0,
      56,     0,     0,   138,     0,     0,     0,     0,     0,     0,
       0,    73,     0,     0,     0,     0,   134,    55,   137
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short int yydefgoto[] =
{
      -1,     6,     7,     8,     9,    10,    11,    25,    26,    73,
      49,    38,    39,    93,    40,    41,   142,   109,   200,   110,
     203,   111,   175,    82,   112,   199,   143,   212,   210,   293,
     315,   211,   225,   152,   154,   145,   235,   114,   163,   115,
     176,   171,   172,   119,   120,    42,    43,    85,    91,    92,
      44
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -119
static const short int yypact[] =
{
     245,    23,  -119,   -38,     6,     9,    41,   235,  -119,  -119,
    -119,  -119,    46,    69,    79,    21,    36,  -119,  -119,  -119,
     478,   482,     2,  -119,    84,     1,  -119,    96,   103,  -119,
    -119,    91,    73,   115,   123,   137,   144,    10,   141,  -119,
    -119,  -119,  -119,  -119,  -119,  -119,   161,   159,  -119,   146,
    -119,  -119,  -119,  -119,   497,   524,   129,   171,   152,   156,
      28,    35,    13,  -119,   452,  -119,  -119,  -119,  -119,   348,
    -119,   184,   167,   174,  -119,   271,  -119,   324,   208,   156,
     452,   180,   218,  -119,   220,    19,  -119,    51,  -119,  -119,
    -119,    12,    98,   185,   452,  -119,   188,   226,   227,   228,
     231,    77,   205,   239,   241,   244,   249,   251,   178,   452,
     452,   452,   149,  -119,    20,   126,  -119,   221,  -119,   374,
    -119,   400,  -119,   263,  -119,  -119,  -119,   267,  -119,   234,
     237,  -119,  -119,  -119,   272,  -119,  -119,  -119,   147,  -119,
     240,   274,   265,  -119,   280,   281,  -119,  -119,   254,  -119,
     291,   292,   300,   197,   308,  -119,  -119,  -119,  -119,  -119,
    -119,  -119,  -119,   312,   298,   305,   309,  -119,   290,   293,
     322,   170,  -119,  -119,   294,  -119,   154,  -119,  -119,   333,
    -119,  -119,  -119,   426,  -119,   297,  -119,   315,  -119,  -119,
     299,    38,   331,  -119,  -119,  -119,  -119,   336,  -119,   303,
     304,    45,   335,   304,   306,   307,  -119,   310,   162,  -119,
     316,   317,   318,  -119,   452,   452,   452,   338,   339,   452,
    -119,  -119,  -119,  -119,   320,   328,   452,  -119,   347,   452,
      58,   361,   156,   156,  -119,   304,   376,   377,   156,   156,
     380,   375,   378,   381,  -119,  -119,   382,   390,   401,  -119,
    -119,  -119,   452,   452,     3,  -119,   402,   295,   452,  -119,
     156,   156,   385,   403,   210,   409,  -119,   404,   405,  -119,
     383,   394,   173,  -119,   452,  -119,    62,   104,  -119,  -119,
    -119,   408,   412,   156,   156,  -119,  -119,   156,   156,  -119,
    -119,  -119,  -119,   395,  -119,   156,   156,   427,   429,   430,
     434,   431,   436,   437,   156,   156,   156,   156,  -119,   156,
     156,   449,   448,   455,   453,   424,   460,   456,  -119,   156,
    -119,   156,   466,  -119,   156,   462,   463,   452,   469,   156,
     156,  -119,   156,   480,   484,   481,  -119,  -119,  -119
};

/* YYPGOTO[NTERM-NUM].  */
static const short int yypgoto[] =
{
    -119,  -119,  -119,   485,  -119,  -119,  -119,  -119,   471,  -119,
    -119,    47,    82,  -119,  -119,  -119,  -109,  -119,  -119,  -119,
    -119,  -119,    24,   -65,  -119,  -119,   -64,  -119,  -119,  -119,
    -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,
     259,  -119,   326,   379,  -118,  -119,  -119,   440,  -119,   407,
    -119
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -119
static const short int yytable[] =
{
     113,   181,    51,    14,   194,   118,    52,    94,  -117,    47,
      15,    95,    16,   136,   127,    96,   128,   137,    88,    63,
     132,    97,    98,    99,   133,   100,    23,   173,   101,   102,
     103,   104,   105,    83,    64,   106,   107,  -117,  -117,  -117,
      86,    17,    24,    48,   108,   164,   165,   166,    89,    89,
      20,   232,   132,    90,    90,   118,   135,   118,   238,    12,
     134,   174,    24,   194,    13,   181,    94,  -116,    46,    84,
      95,   260,    27,    21,    96,   192,    84,    28,   196,   129,
      97,    98,    99,   202,   100,    22,   129,   101,   102,   103,
     104,   105,   134,    50,   106,   107,  -116,  -116,  -116,   129,
      54,    75,    77,   108,    57,   194,   139,    55,    94,  -118,
     254,   140,    95,   150,    58,    56,    96,   257,   151,   118,
      67,    59,    97,    98,    99,   231,   100,    60,    67,   101,
     102,   103,   104,   105,   177,   178,   106,   107,  -118,  -118,
    -118,    61,    65,   276,   277,   108,    66,    70,    62,    30,
     249,   250,   251,    71,   167,   189,    72,    67,    31,    67,
     190,   223,    65,    69,   224,   259,    68,   262,   263,    30,
      78,    32,    33,   267,   268,   220,    80,    79,    31,    34,
      35,    36,    37,   168,   169,   170,   160,   161,   121,   162,
     196,    32,    33,   196,   280,   281,   282,    81,   244,    34,
      35,    36,    37,   245,   168,   169,   170,   207,   122,   291,
     294,   208,   196,   196,   292,   123,   126,   285,   297,   298,
     224,   129,   299,   300,   237,   130,   141,   240,   131,   144,
     302,   303,   146,   147,   148,    -2,    18,   149,     1,   311,
     312,   313,   314,     2,   316,   317,   153,   155,     1,   156,
       3,     4,   157,     2,   325,   158,   326,   159,     5,   328,
       3,     4,   179,   331,   333,   334,   194,   335,     5,    94,
     195,   184,    65,    95,   185,   186,   124,    96,   187,    30,
     188,   191,   193,    97,    98,    99,   197,   100,    31,   198,
     101,   102,   103,   104,   105,   201,   194,   106,   107,    94,
     279,    32,    33,    95,   204,   205,   108,    96,   206,    34,
      35,    36,    37,    97,    98,    99,   209,   100,   213,   214,
     101,   102,   103,   104,   105,    65,   215,   106,   107,   125,
     216,   217,    30,   219,   218,   222,   108,   226,   228,   229,
     230,    31,   233,   234,   236,   174,   239,   241,   242,   252,
     253,   243,    94,   116,    32,    33,    95,   246,   247,   248,
      96,   255,    34,    35,    36,    37,    97,    98,    99,   256,
     100,   258,   261,   101,   102,   103,   104,   105,    94,   180,
     106,   107,    95,   265,   266,   117,    96,   269,   270,   108,
     273,   271,    97,    98,    99,   272,   100,   274,   283,   101,
     102,   103,   104,   105,    94,   182,   106,   107,    95,   275,
     278,   117,    96,   286,   284,   108,   288,   287,    97,    98,
      99,   295,   100,   296,   289,   101,   102,   103,   104,   105,
      94,   227,   106,   107,    95,   290,   301,   117,    96,   308,
     304,   108,   305,   306,    97,    98,    99,   307,   100,   309,
     310,   101,   102,   103,   104,   105,    94,   318,   106,   107,
      95,   319,   320,   117,    96,   322,   321,   108,   323,   324,
      97,    98,    99,   327,   100,   329,   330,   101,   102,   103,
     104,   105,   332,    29,   106,   107,    30,    45,   336,   338,
      30,   337,    19,   108,   264,    31,    53,   221,   138,    31,
     183,    87,    74,     0,     0,    30,     0,     0,    32,    33,
       0,     0,    32,    33,    31,     0,    34,    35,    36,    37,
      34,    35,    36,    37,     0,     0,     0,    32,    33,    76,
       0,     0,    30,     0,     0,    34,    35,    36,    37,     0,
       0,    31,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    32,    33,     0,     0,     0,     0,
       0,     0,    34,    35,    36,    37
};

static const short int yycheck[] =
{
      64,   119,     1,    41,     1,    69,     5,     4,     5,     7,
       4,     8,     3,     1,    79,    12,    80,     5,     5,     9,
       1,    18,    19,    20,     5,    22,     5,     7,    25,    26,
      27,    28,    29,     5,    24,    32,    33,    34,    35,    36,
       5,     0,    41,    41,    41,   109,   110,   111,    36,    36,
       4,    13,     1,    41,    41,   119,     5,   121,    13,    36,
      41,    41,    41,     1,    41,   183,     4,     5,    21,    41,
       8,    13,    36,     4,    12,   140,    41,    41,   142,    41,
      18,    19,    20,   148,    22,     6,    41,    25,    26,    27,
      28,    29,    41,     9,    32,    33,    34,    35,    36,    41,
       4,    54,    55,    41,    31,     1,     8,     4,     4,     5,
     219,    13,     8,    36,    41,    24,    12,   226,    41,   183,
      38,     6,    18,    19,    20,   190,    22,     4,    46,    25,
      26,    27,    28,    29,     8,     9,    32,    33,    34,    35,
      36,     4,     1,   252,   253,    41,     5,     1,     4,     8,
     214,   215,   216,     7,     5,     8,    10,    75,    17,    77,
      13,     7,     1,     4,    10,   229,     5,   232,   233,     8,
      41,    30,    31,   238,   239,     5,    24,     6,    17,    38,
      39,    40,    41,    34,    35,    36,     8,     9,     4,    11,
     254,    30,    31,   257,   258,   260,   261,    41,    36,    38,
      39,    40,    41,    41,    34,    35,    36,    10,    41,    36,
     274,    14,   276,   277,    41,    41,     8,     7,   283,   284,
      10,    41,   287,   288,   200,     7,    41,   203,     8,    41,
     295,   296,     6,     6,     6,     0,     1,     6,     3,   304,
     305,   306,   307,     8,   309,   310,    41,     8,     3,     8,
      15,    16,     8,     8,   319,     6,   321,     6,    23,   324,
      15,    16,    41,   327,   329,   330,     1,   332,    23,     4,
       5,     8,     1,     8,     7,    41,     5,    12,    41,     8,
       8,    41,     8,    18,    19,    20,     6,    22,    17,     8,
      25,    26,    27,    28,    29,    41,     1,    32,    33,     4,
       5,    30,    31,     8,    13,    13,    41,    12,     8,    38,
      39,    40,    41,    18,    19,    20,     8,    22,     6,    21,
      25,    26,    27,    28,    29,     1,    21,    32,    33,     5,
      21,    41,     8,    11,    41,    41,    41,     4,    41,    24,
      41,    17,    11,     7,    41,    41,    11,    41,    41,    11,
      11,    41,     4,     5,    30,    31,     8,    41,    41,    41,
      12,    41,    38,    39,    40,    41,    18,    19,    20,    41,
      22,    24,    11,    25,    26,    27,    28,    29,     4,     5,
      32,    33,     8,     7,     7,    37,    12,     7,    13,    41,
       8,    13,    18,    19,    20,    14,    22,     7,    13,    25,
      26,    27,    28,    29,     4,     5,    32,    33,     8,     8,
       8,    37,    12,     4,    11,    41,    11,    13,    18,    19,
      20,    13,    22,    11,    41,    25,    26,    27,    28,    29,
       4,     5,    32,    33,     8,    41,    41,    37,    12,     8,
      13,    41,    13,    13,    18,    19,    20,    13,    22,    13,
      13,    25,    26,    27,    28,    29,     4,     8,    32,    33,
       8,    13,     7,    37,    12,    41,    13,    41,     8,    13,
      18,    19,    20,     7,    22,    13,    13,    25,    26,    27,
      28,    29,    13,     5,    32,    33,     8,     5,     8,     8,
       8,     7,     7,    41,   235,    17,    25,   171,    91,    17,
     121,    61,     5,    -1,    -1,     8,    -1,    -1,    30,    31,
      -1,    -1,    30,    31,    17,    -1,    38,    39,    40,    41,
      38,    39,    40,    41,    -1,    -1,    -1,    30,    31,     5,
      -1,    -1,     8,    -1,    -1,    38,    39,    40,    41,    -1,
      -1,    17,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    30,    31,    -1,    -1,    -1,    -1,
      -1,    -1,    38,    39,    40,    41
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     3,     8,    15,    16,    23,    43,    44,    45,    46,
      47,    48,    36,    41,    41,     4,     3,     0,     1,    45,
       4,     4,     6,     5,    41,    49,    50,    36,    41,     5,
       8,    17,    30,    31,    38,    39,    40,    41,    53,    54,
      56,    57,    87,    88,    92,     5,    53,     7,    41,    52,
       9,     1,     5,    50,     4,     4,    24,    31,    41,     6,
       4,     4,     4,     9,    24,     1,     5,    54,     5,     4,
       1,     7,    10,    51,     5,    53,     5,    53,    41,     6,
      24,    41,    65,     5,    41,    89,     5,    89,     5,    36,
      41,    90,    91,    55,     4,     8,    12,    18,    19,    20,
      22,    25,    26,    27,    28,    29,    32,    33,    41,    59,
      61,    63,    66,    68,    79,    81,     5,    37,    68,    85,
      86,     4,    41,    41,     5,     5,     8,    65,    68,    41,
       7,     8,     1,     5,    41,     5,     1,     5,    91,     8,
      13,    41,    58,    68,    41,    77,     6,     6,     6,     6,
      36,    41,    75,    41,    76,     8,     8,     8,     6,     6,
       8,     9,    11,    80,    68,    68,    68,     5,    34,    35,
      36,    83,    84,     7,    41,    64,    82,     8,     9,    41,
       5,    86,     5,    85,     8,     7,    41,    41,     8,     8,
      13,    41,    65,     8,     1,     5,    68,     6,     8,    67,
      60,    41,    65,    62,    13,    13,     8,    10,    14,     8,
      70,    73,    69,     6,    21,    21,    21,    41,    41,    11,
       5,    84,    41,     7,    10,    74,     4,     5,    41,    24,
      41,    65,    13,    11,     7,    78,    41,    64,    13,    11,
      64,    41,    41,    41,    36,    41,    41,    41,    41,    68,
      68,    68,    11,    11,    58,    41,    41,    58,    24,    68,
      13,    11,    65,    65,    82,     7,     7,    65,    65,     7,
      13,    13,    14,     8,     7,     8,    58,    58,     8,     5,
      68,    65,    65,    13,    11,     7,     4,    13,    11,    41,
      41,    36,    41,    71,    68,    13,    11,    65,    65,    65,
      65,    41,    65,    65,    13,    13,    13,    13,     8,    13,
      13,    65,    65,    65,    65,    72,    65,    65,     8,    13,
       7,    13,    41,     8,    13,    65,    65,     7,    65,    13,
      13,    68,    13,    65,    65,    65,     8,     7,     8
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (&yylloc, NULL, YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (0)


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (N)								\
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (0)
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
              (Loc).first_line, (Loc).first_column,	\
              (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, &yylloc, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval, &yylloc)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr,					\
                  Type, Value, Location);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname[yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      size_t yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

#endif /* YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;
  (void) yylocationp;

  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");

# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;
  (void) yylocationp;

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *NULL);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */






/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void *NULL)
#else
int
yyparse (NULL)
    void *NULL;
#endif
#endif
{
  /* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;
/* Location data for the look-ahead symbol.  */
YYLTYPE yylloc;

  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;

  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
  /* The locations where the error started and ended. */
  YYLTYPE yyerror_range[2];

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;
#if YYLTYPE_IS_TRIVIAL
  /* Initialize the default location before parsing starts.  */
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 0;
#endif

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
	YYSTACK_RELOCATE (yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a look-ahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to look-ahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
  *++yylsp = yylloc;

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, yylsp - yylen, yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 139 "ael.y"
    {((struct parse_io *)parseio)->pval = (yyval.pval); ((struct parse_io *)parseio)->syntax_error_count = ael_errcnt;;}
    break;

  case 3:
#line 142 "ael.y"
    {(yyval.pval)=(yyvsp[0].pval);;}
    break;

  case 4:
#line 143 "ael.y"
    {if ( (yyvsp[-1].pval) && (yyvsp[0].pval) ) {(yyval.pval)=(yyvsp[-1].pval); linku1((yyval.pval),(yyvsp[0].pval));} 
						 else if ( (yyvsp[-1].pval) ) {(yyval.pval)=(yyvsp[-1].pval);}
						 else if ( (yyvsp[0].pval) ) {(yyval.pval)=(yyvsp[0].pval);} ;}
    break;

  case 6:
#line 149 "ael.y"
    {(yyval.pval)=(yyvsp[0].pval);;}
    break;

  case 7:
#line 150 "ael.y"
    {(yyval.pval)=(yyvsp[0].pval);;}
    break;

  case 8:
#line 151 "ael.y"
    {(yyval.pval)=(yyvsp[0].pval);;}
    break;

  case 9:
#line 152 "ael.y"
    {(yyval.pval)=0;/* allow older docs to be read */;}
    break;

  case 10:
#line 155 "ael.y"
    {(yyval.pval)=npval(PV_CONTEXT,(yylsp[-4]).first_line,(yylsp[0]).last_line, (yylsp[-4]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.str = (yyvsp[-3].str); (yyval.pval)->u2.statements = (yyvsp[-1].pval); ;}
    break;

  case 11:
#line 156 "ael.y"
    {(yyval.pval)=npval(PV_CONTEXT,(yylsp[-3]).first_line,(yylsp[0]).last_line, (yylsp[-3]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.str = (yyvsp[-2].str); ;}
    break;

  case 12:
#line 157 "ael.y"
    {(yyval.pval)=npval(PV_CONTEXT,(yylsp[-4]).first_line,(yylsp[0]).last_line, (yylsp[-4]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.str = strdup("default"); (yyval.pval)->u2.statements = (yyvsp[-1].pval); ;}
    break;

  case 13:
#line 158 "ael.y"
    {(yyval.pval)=npval(PV_CONTEXT,(yylsp[-3]).first_line,(yylsp[0]).last_line, (yylsp[-3]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.str = strdup("default"); ;}
    break;

  case 14:
#line 159 "ael.y"
    {(yyval.pval)=npval(PV_CONTEXT,(yylsp[-5]).first_line,(yylsp[0]).last_line, (yylsp[-5]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.str = (yyvsp[-3].str); (yyval.pval)->u2.statements = (yyvsp[-1].pval);  (yyval.pval)->u3.abstract = 1;;}
    break;

  case 15:
#line 160 "ael.y"
    {(yyval.pval)=npval(PV_CONTEXT,(yylsp[-4]).first_line,(yylsp[0]).last_line, (yylsp[-4]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.str = (yyvsp[-2].str); (yyval.pval)->u3.abstract = 1; ;}
    break;

  case 16:
#line 161 "ael.y"
    {(yyval.pval)=npval(PV_CONTEXT,(yylsp[-5]).first_line,(yylsp[0]).last_line, (yylsp[-5]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.str = strdup("default"); (yyval.pval)->u2.statements = (yyvsp[-1].pval); (yyval.pval)->u3.abstract = 1; ;}
    break;

  case 17:
#line 162 "ael.y"
    {(yyval.pval)=npval(PV_CONTEXT,(yylsp[-4]).first_line,(yylsp[0]).last_line, (yylsp[-4]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.str = strdup("default"); (yyval.pval)->u3.abstract = 1; ;}
    break;

  case 18:
#line 165 "ael.y"
    {(yyval.pval)=npval(PV_MACRO,(yylsp[-7]).first_line,(yylsp[0]).last_line, (yylsp[-7]).first_column, (yylsp[0]).last_column); 
																	 (yyval.pval)->u1.str = (yyvsp[-6].str); (yyval.pval)->u2.arglist = (yyvsp[-4].pval); (yyval.pval)->u3.macro_statements = (yyvsp[-1].pval); ;}
    break;

  case 19:
#line 167 "ael.y"
    {(yyval.pval)=npval(PV_MACRO,(yylsp[-6]).first_line,(yylsp[0]).last_line, (yylsp[-6]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.str = (yyvsp[-5].str); (yyval.pval)->u2.arglist = (yyvsp[-3].pval); ;}
    break;

  case 20:
#line 168 "ael.y"
    {(yyval.pval)=npval(PV_MACRO,(yylsp[-6]).first_line,(yylsp[0]).last_line, (yylsp[-6]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.str = (yyvsp[-5].str); (yyval.pval)->u3.macro_statements = (yyvsp[-1].pval); ;}
    break;

  case 21:
#line 169 "ael.y"
    {(yyval.pval)=npval(PV_MACRO,(yylsp[-5]).first_line,(yylsp[0]).last_line, (yylsp[-5]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.str = (yyvsp[-4].str); /* pretty empty! */ ;}
    break;

  case 22:
#line 172 "ael.y"
    {(yyval.pval)=npval(PV_GLOBALS,(yylsp[-3]).first_line,(yylsp[0]).last_line, (yylsp[-3]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.statements = (yyvsp[-1].pval);;}
    break;

  case 23:
#line 173 "ael.y"
    {(yyval.pval)=npval(PV_GLOBALS,(yylsp[-2]).first_line,(yylsp[0]).last_line, (yylsp[-2]).first_column, (yylsp[0]).last_column); /* and that's all */ ;}
    break;

  case 24:
#line 176 "ael.y"
    {(yyval.pval)=(yyvsp[0].pval);;}
    break;

  case 25:
#line 177 "ael.y"
    {(yyval.pval)=(yyvsp[-1].pval); linku1((yyval.pval),(yyvsp[0].pval));;}
    break;

  case 27:
#line 181 "ael.y"
    {reset_semicount(((struct parse_io *)parseio)->scanner);;}
    break;

  case 28:
#line 181 "ael.y"
    {(yyval.pval)=npval(PV_VARDEC,(yylsp[-4]).first_line,(yylsp[0]).last_line, (yylsp[-4]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.str = (yyvsp[-4].str);(yyval.pval)->u2.val = (yyvsp[-1].str); ;}
    break;

  case 29:
#line 184 "ael.y"
    {(yyval.pval)= npval(PV_WORD,(yylsp[0]).first_line,(yylsp[0]).last_line, (yylsp[0]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.str = (yyvsp[0].str); ;}
    break;

  case 30:
#line 185 "ael.y"
    {pval *z = npval(PV_WORD,(yylsp[-2]).first_line,(yylsp[0]).last_line, (yylsp[-2]).first_column, (yylsp[0]).last_column); z->u1.str = (yyvsp[0].str); (yyval.pval)=(yyvsp[-2].pval); linku1((yyval.pval),z); ;}
    break;

  case 32:
#line 189 "ael.y"
    { (yyval.pval)=(yyvsp[0].pval);;}
    break;

  case 33:
#line 190 "ael.y"
    { if ( (yyvsp[-1].pval) && (yyvsp[0].pval) ) {(yyval.pval)=(yyvsp[-1].pval); linku1((yyval.pval),(yyvsp[0].pval));} 
						 else if ( (yyvsp[-1].pval) ) {(yyval.pval)=(yyvsp[-1].pval);}
						 else if ( (yyvsp[0].pval) ) {(yyval.pval)=(yyvsp[0].pval);} ;}
    break;

  case 34:
#line 193 "ael.y"
    { (yyval.pval)=(yyvsp[-1].pval);;}
    break;

  case 35:
#line 196 "ael.y"
    {(yyval.pval)=(yyvsp[0].pval);;}
    break;

  case 36:
#line 197 "ael.y"
    {(yyval.pval)=(yyvsp[0].pval);;}
    break;

  case 37:
#line 198 "ael.y"
    {(yyval.pval)=(yyvsp[0].pval);;}
    break;

  case 38:
#line 199 "ael.y"
    {(yyval.pval)=(yyvsp[0].pval);;}
    break;

  case 39:
#line 200 "ael.y"
    {(yyval.pval)=(yyvsp[0].pval);;}
    break;

  case 40:
#line 201 "ael.y"
    {reset_semicount(((struct parse_io *)parseio)->scanner);;}
    break;

  case 41:
#line 201 "ael.y"
    {(yyval.pval)=npval(PV_VARDEC,(yylsp[-4]).first_line,(yylsp[0]).last_line, (yylsp[-4]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.str = (yyvsp[-4].str);(yyval.pval)->u2.val = (yyvsp[-1].str); ;}
    break;

  case 42:
#line 202 "ael.y"
    {(yyval.pval)=0;/* allow older docs to be read */;}
    break;

  case 43:
#line 205 "ael.y"
    { (yyval.pval)=npval(PV_IGNOREPAT,(yylsp[-3]).first_line,(yylsp[0]).last_line, (yylsp[-3]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.str = (yyvsp[-1].str);;}
    break;

  case 44:
#line 208 "ael.y"
    {(yyval.pval) = npval(PV_EXTENSION,(yylsp[-2]).first_line,(yylsp[0]).last_line, (yylsp[-2]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.str = (yyvsp[-2].str); (yyval.pval)->u2.statements = (yyvsp[0].pval); ;}
    break;

  case 45:
#line 209 "ael.y"
    {(yyval.pval) = npval(PV_EXTENSION,(yylsp[-3]).first_line,(yylsp[-1]).last_line, (yylsp[-3]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.str = (yyvsp[-2].str); (yyval.pval)->u2.statements = (yyvsp[0].pval); (yyval.pval)->u4.regexten=1;;}
    break;

  case 46:
#line 210 "ael.y"
    {(yyval.pval) = npval(PV_EXTENSION,(yylsp[-6]).first_line,(yylsp[0]).last_line, (yylsp[-6]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.str = (yyvsp[-2].str); (yyval.pval)->u2.statements = (yyvsp[0].pval); (yyval.pval)->u3.hints = (yyvsp[-4].str);;}
    break;

  case 47:
#line 211 "ael.y"
    {(yyval.pval) = npval(PV_EXTENSION,(yylsp[-7]).first_line,(yylsp[-4]).last_line, (yylsp[-7]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.str = (yyvsp[-2].str); (yyval.pval)->u2.statements = (yyvsp[0].pval); (yyval.pval)->u4.regexten=1;(yyval.pval)->u3.hints = (yyvsp[-4].str);;}
    break;

  case 48:
#line 215 "ael.y"
    {(yyval.pval)=(yyvsp[0].pval);;}
    break;

  case 49:
#line 216 "ael.y"
    {if ( (yyvsp[-1].pval) && (yyvsp[0].pval) ) {(yyval.pval)=(yyvsp[-1].pval); linku1((yyval.pval),(yyvsp[0].pval));} 
						 else if ( (yyvsp[-1].pval) ) {(yyval.pval)=(yyvsp[-1].pval);}
						 else if ( (yyvsp[0].pval) ) {(yyval.pval)=(yyvsp[0].pval);} ;}
    break;

  case 51:
#line 222 "ael.y"
    {reset_parencount(((struct parse_io *)parseio)->scanner);;}
    break;

  case 52:
#line 222 "ael.y"
    { (yyval.pval)= npval(PV_IF,(yylsp[-4]).first_line,(yylsp[0]).last_line, (yylsp[-4]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.str = (yyvsp[-1].str); ;}
    break;

  case 53:
#line 225 "ael.y"
    {reset_parencount(((struct parse_io *)parseio)->scanner);;}
    break;

  case 54:
#line 225 "ael.y"
    { (yyval.pval)= npval(PV_RANDOM,(yylsp[-4]).first_line,(yylsp[0]).last_line, (yylsp[-4]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.str=(yyvsp[-1].str);;}
    break;

  case 55:
#line 228 "ael.y"
    { (yyval.pval)= npval(PV_IFTIME,(yylsp[-13]).first_line,(yylsp[-9]).last_line, (yylsp[-13]).first_column, (yylsp[-9]).last_column); 
					(yyval.pval)->u1.list = npval(PV_WORD,(yylsp[-11]).first_line,(yylsp[-11]).last_line, (yylsp[-11]).first_column, (yylsp[-11]).last_column); 
					(yyval.pval)->u1.list->u1.str = (char*)malloc(strlen((yyvsp[-11].str))+strlen((yyvsp[-9].str))+strlen((yyvsp[-7].str))+4);
					strcpy((yyval.pval)->u1.list->u1.str,(yyvsp[-11].str));
					strcat((yyval.pval)->u1.list->u1.str,":");
					strcat((yyval.pval)->u1.list->u1.str,(yyvsp[-9].str));
					strcat((yyval.pval)->u1.list->u1.str,":");
					strcat((yyval.pval)->u1.list->u1.str,(yyvsp[-7].str));
					free((yyvsp[-11].str));
					free((yyvsp[-9].str));
					free((yyvsp[-7].str));
					(yyval.pval)->u1.list->next = npval(PV_WORD,(yylsp[-5]).first_line,(yylsp[-5]).last_line, (yylsp[-5]).first_column, (yylsp[-5]).last_column); 
					(yyval.pval)->u1.list->next->u1.str = (yyvsp[-5].str); 
					(yyval.pval)->u1.list->next->next = npval(PV_WORD,(yylsp[-3]).first_line,(yylsp[-3]).last_line, (yylsp[-3]).first_column, (yylsp[-3]).last_column); 
					(yyval.pval)->u1.list->next->next->u1.str = (yyvsp[-3].str); 
					(yyval.pval)->u1.list->next->next->next = npval(PV_WORD,(yylsp[-1]).first_line,(yylsp[-1]).last_line, (yylsp[-1]).first_column, (yylsp[-1]).last_column); 
					(yyval.pval)->u1.list->next->next->next->u1.str = (yyvsp[-1].str); 
					prev_word = 0;
		;}
    break;

  case 56:
#line 247 "ael.y"
    { (yyval.pval)= npval(PV_IFTIME,(yylsp[-9]).first_line,(yylsp[-5]).last_line, (yylsp[-9]).first_column, (yylsp[-5]).last_column); 
					(yyval.pval)->u1.list = npval(PV_WORD,(yylsp[-7]).first_line,(yylsp[-7]).last_line, (yylsp[-7]).first_column, (yylsp[-7]).last_column); 
					(yyval.pval)->u1.list->u1.str = (yyvsp[-7].str);
					(yyval.pval)->u1.list->next = npval(PV_WORD,(yylsp[-5]).first_line,(yylsp[-5]).last_line, (yylsp[-5]).first_column, (yylsp[-5]).last_column); 
					(yyval.pval)->u1.list->next->u1.str = (yyvsp[-5].str); 
					(yyval.pval)->u1.list->next->next = npval(PV_WORD,(yylsp[-3]).first_line,(yylsp[-3]).last_line, (yylsp[-3]).first_column, (yylsp[-3]).last_column); 
					(yyval.pval)->u1.list->next->next->u1.str = (yyvsp[-3].str); 
					(yyval.pval)->u1.list->next->next->next = npval(PV_WORD,(yylsp[-1]).first_line,(yylsp[-1]).last_line, (yylsp[-1]).first_column, (yylsp[-1]).last_column); 
					(yyval.pval)->u1.list->next->next->next->u1.str = (yyvsp[-1].str); 
					prev_word = 0;
		;}
    break;

  case 57:
#line 266 "ael.y"
    { (yyval.str) = (yyvsp[0].str);;}
    break;

  case 58:
#line 267 "ael.y"
    { (yyval.str) = (char*)malloc(strlen((yyvsp[-1].str))+strlen((yyvsp[0].str))+1); strcpy((yyval.str), (yyvsp[-1].str)); strcat((yyval.str), (yyvsp[0].str));  free((yyvsp[-1].str)); free((yyvsp[0].str));prev_word = (yyval.str);;}
    break;

  case 59:
#line 269 "ael.y"
    { (yyval.str) = (yyvsp[0].str);;}
    break;

  case 60:
#line 270 "ael.y"
    { (yyval.str) = (char*)malloc(strlen((yyvsp[-1].str))+strlen((yyvsp[0].str))+1); strcpy((yyval.str), (yyvsp[-1].str)); strcat((yyval.str), (yyvsp[0].str));  free((yyvsp[-1].str)); free((yyvsp[0].str));prev_word = (yyval.str);;}
    break;

  case 61:
#line 271 "ael.y"
    { (yyval.str) = (char*)malloc(strlen((yyvsp[-2].str))+strlen((yyvsp[-1].str))+strlen((yyvsp[0].str))+1); strcpy((yyval.str), (yyvsp[-2].str)); strcat((yyval.str), (yyvsp[-1].str));  strcat((yyval.str), (yyvsp[0].str));  free((yyvsp[-2].str)); free((yyvsp[-1].str)); free((yyvsp[0].str));prev_word=(yyval.str);;}
    break;

  case 62:
#line 274 "ael.y"
    {reset_parencount(((struct parse_io *)parseio)->scanner);;}
    break;

  case 63:
#line 275 "ael.y"
    {(yyval.pval)=npval(PV_SWITCH,(yylsp[-5]).first_line,(yylsp[0]).last_line, (yylsp[-5]).first_column, (yylsp[0]).last_column);
						(yyval.pval)->u1.str = (yyvsp[-2].str); ;}
    break;

  case 64:
#line 279 "ael.y"
    {(yyval.pval)=npval(PV_STATEMENTBLOCK,(yylsp[-2]).first_line,(yylsp[0]).last_line, (yylsp[-2]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.list = (yyvsp[-1].pval); ;}
    break;

  case 65:
#line 280 "ael.y"
    {reset_semicount(((struct parse_io *)parseio)->scanner);;}
    break;

  case 66:
#line 281 "ael.y"
    {(yyval.pval)=npval(PV_VARDEC,(yylsp[-4]).first_line,(yylsp[0]).last_line, (yylsp[-4]).first_column, (yylsp[0]).last_column); 
				(yyval.pval)->u1.str = (yyvsp[-4].str); (yyval.pval)->u2.val = (yyvsp[-1].str); ;}
    break;

  case 67:
#line 283 "ael.y"
    {(yyval.pval)=npval(PV_GOTO,(yylsp[-2]).first_line,(yylsp[0]).last_line, (yylsp[-2]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.list = (yyvsp[-1].pval);;}
    break;

  case 68:
#line 284 "ael.y"
    {(yyval.pval)=npval(PV_GOTO,(yylsp[-2]).first_line,(yylsp[0]).last_line, (yylsp[-2]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.list = (yyvsp[-1].pval);;}
    break;

  case 69:
#line 285 "ael.y"
    {(yyval.pval)=npval(PV_LABEL,(yylsp[-1]).first_line,(yylsp[0]).last_line, (yylsp[-1]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.str = (yyvsp[-1].str); ;}
    break;

  case 70:
#line 286 "ael.y"
    {reset_semicount(((struct parse_io *)parseio)->scanner);;}
    break;

  case 71:
#line 287 "ael.y"
    {reset_semicount(((struct parse_io *)parseio)->scanner);;}
    break;

  case 72:
#line 288 "ael.y"
    {reset_parencount(((struct parse_io *)parseio)->scanner);;}
    break;

  case 73:
#line 289 "ael.y"
    { (yyval.pval)=npval(PV_FOR,(yylsp[-11]).first_line,(yylsp[0]).last_line, (yylsp[-11]).first_column, (yylsp[0]).last_column); 
						(yyval.pval)->u1.for_init = (yyvsp[-8].str); (yyval.pval)->u2.for_test=(yyvsp[-5].str); (yyval.pval)->u3.for_inc = (yyvsp[-2].str); (yyval.pval)->u4.for_statements = (yyvsp[0].pval);;}
    break;

  case 74:
#line 291 "ael.y"
    {reset_parencount(((struct parse_io *)parseio)->scanner);;}
    break;

  case 75:
#line 292 "ael.y"
    {(yyval.pval)=npval(PV_WHILE,(yylsp[-5]).first_line,(yylsp[0]).last_line, (yylsp[-5]).first_column, (yylsp[0]).last_column); 
					(yyval.pval)->u1.str = (yyvsp[-2].str); (yyval.pval)->u2.statements = (yyvsp[0].pval); ;}
    break;

  case 76:
#line 294 "ael.y"
    {(yyval.pval)=(yyvsp[-1].pval);(yyval.pval)->endline = (yylsp[0]).last_line; (yyval.pval)->endcol = (yylsp[0]).last_column;;}
    break;

  case 77:
#line 295 "ael.y"
    {(yyval.pval)=(yyvsp[-2].pval); (yyval.pval)->u2.statements = (yyvsp[-1].pval);(yyval.pval)->endline = (yylsp[0]).last_line; (yyval.pval)->endcol = (yylsp[0]).last_column;;}
    break;

  case 78:
#line 296 "ael.y"
    {(yyval.pval) = (yyvsp[-1].pval);(yyval.pval)->endline = (yylsp[-1]).last_line; (yyval.pval)->endcol = (yylsp[-1]).last_column;;}
    break;

  case 79:
#line 297 "ael.y"
    { (yyval.pval) = (yyvsp[-1].pval);(yyval.pval)->endline = (yylsp[0]).last_line; (yyval.pval)->endcol = (yylsp[0]).last_column;;}
    break;

  case 80:
#line 298 "ael.y"
    { (yyval.pval)= npval(PV_APPLICATION_CALL,(yylsp[-1]).first_line,(yylsp[0]).last_line, (yylsp[-1]).first_column, (yylsp[0]).last_column); 
																						(yyval.pval)->u1.str = (yyvsp[-1].str);;}
    break;

  case 81:
#line 300 "ael.y"
    {reset_semicount(((struct parse_io *)parseio)->scanner);;}
    break;

  case 82:
#line 300 "ael.y"
    {
                          char *bufx;
						  int tot=0;
						  pval *pptr;
						  
                          (yyval.pval) = npval(PV_VARDEC,(yylsp[-4]).first_line,(yylsp[0]).last_line, (yylsp[-4]).first_column, (yylsp[0]).last_column);
						  (yyval.pval)->u2.val=(yyvsp[-1].str);
						  /* rebuild the original string-- this is not an app call, it's an unwrapped vardec, with a func call on the LHS */
                          /* string to big to fit in the buffer? */
						  tot+=strlen((yyvsp[-4].pval)->u1.str);
						  for(pptr=(yyvsp[-4].pval)->u2.arglist;pptr;pptr=pptr->next) {
							  tot+=strlen(pptr->u1.str);
							  tot++; /* for a sep like a comma */
						  }
						  tot+=4; /* for safety */
						  bufx = (char *)malloc(tot);
						  strcpy(bufx,(yyvsp[-4].pval)->u1.str);
						  strcat(bufx,"(");
						  for (pptr=(yyvsp[-4].pval)->u2.arglist;pptr;pptr=pptr->next) {
							  if ( pptr != (yyvsp[-4].pval)->u2.arglist )
								  strcat(bufx,",");
							  strcat(bufx,pptr->u1.str);
						  }
						  strcat(bufx,")");
						  
						  if ( !ael_is_funcname((yyvsp[-4].pval)->u1.str) )
                              ast_log(LOG_WARNING, "==== File: %s, Line %d, Cols: %d-%d: Function call? The name %s is not in my internal list of function names\n", 
									  my_file, (yylsp[-4]).first_line, (yylsp[-4]).first_column, (yylsp[-4]).last_column, (yyvsp[-4].pval)->u1.str);
						  (yyval.pval)->u1.str = bufx;
						  destroy_pval((yyvsp[-4].pval)); /* the app call it is not, get rid of that chain */
						  prev_word = 0;
                       ;}
    break;

  case 83:
#line 332 "ael.y"
    { (yyval.pval) = npval(PV_BREAK,(yylsp[-1]).first_line,(yylsp[0]).last_line, (yylsp[-1]).first_column, (yylsp[0]).last_column);;}
    break;

  case 84:
#line 333 "ael.y"
    {(yyval.pval) = npval(PV_RETURN,(yylsp[-1]).first_line,(yylsp[0]).last_line, (yylsp[-1]).first_column, (yylsp[0]).last_column);;}
    break;

  case 85:
#line 334 "ael.y"
    {(yyval.pval) = npval(PV_CONTINUE,(yylsp[-1]).first_line,(yylsp[0]).last_line, (yylsp[-1]).first_column, (yylsp[0]).last_column);;}
    break;

  case 86:
#line 335 "ael.y"
    {(yyval.pval)=(yyvsp[-1].pval); (yyval.pval)->u2.statements = (yyvsp[0].pval);(yyval.pval)->endline = (yylsp[0]).last_line; (yyval.pval)->endcol = (yylsp[0]).last_column;;}
    break;

  case 87:
#line 336 "ael.y"
    {(yyval.pval)=(yyvsp[-3].pval); (yyval.pval)->u2.statements = (yyvsp[-2].pval);(yyval.pval)->endline = (yylsp[-2]).last_line; (yyval.pval)->endcol = (yylsp[-2]).last_column; (yyval.pval)->u3.else_statements = (yyvsp[0].pval);;}
    break;

  case 88:
#line 337 "ael.y"
    {(yyval.pval)=(yyvsp[-1].pval); (yyval.pval)->u2.statements = (yyvsp[0].pval);(yyval.pval)->endline = (yylsp[0]).last_line; (yyval.pval)->endcol = (yylsp[0]).last_column;;}
    break;

  case 89:
#line 338 "ael.y"
    {(yyval.pval)=(yyvsp[-3].pval); (yyval.pval)->u2.statements = (yyvsp[-2].pval);(yyval.pval)->endline = (yylsp[-2]).last_line; (yyval.pval)->endcol = (yylsp[-2]).last_column; (yyval.pval)->u3.else_statements = (yyvsp[0].pval);;}
    break;

  case 90:
#line 339 "ael.y"
    {(yyval.pval)=(yyvsp[-1].pval); (yyval.pval)->u2.statements = (yyvsp[0].pval);(yyval.pval)->endline = (yylsp[0]).last_line; (yyval.pval)->endcol = (yylsp[0]).last_column;;}
    break;

  case 91:
#line 340 "ael.y"
    {(yyval.pval)=(yyvsp[-3].pval); (yyval.pval)->u2.statements = (yyvsp[-2].pval);(yyval.pval)->endline = (yylsp[-2]).last_line; (yyval.pval)->endcol = (yylsp[-2]).last_column; (yyval.pval)->u3.else_statements = (yyvsp[0].pval);;}
    break;

  case 92:
#line 341 "ael.y"
    { (yyval.pval)=0; ;}
    break;

  case 93:
#line 344 "ael.y"
    { (yyval.pval) = npval(PV_WORD,(yylsp[0]).first_line,(yylsp[0]).last_line, (yylsp[0]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.str = (yyvsp[0].str);;}
    break;

  case 94:
#line 345 "ael.y"
    {(yyval.pval)=npval(PV_WORD,(yylsp[-2]).first_line,(yylsp[-2]).last_line, (yylsp[-2]).first_column, (yylsp[-2]).last_column); 
					(yyval.pval)->u1.str = (yyvsp[-2].str); (yyval.pval)->next = npval(PV_WORD,(yylsp[0]).first_line,(yylsp[0]).last_line, (yylsp[0]).first_column, (yylsp[0]).last_column); 
					(yyval.pval)->next->u1.str = (yyvsp[0].str);;}
    break;

  case 95:
#line 348 "ael.y"
    {(yyval.pval)=npval(PV_WORD,(yylsp[-4]).first_line,(yylsp[-4]).last_line, (yylsp[-4]).first_column, (yylsp[-4]).last_column); 
					(yyval.pval)->u1.str = (yyvsp[-4].str); (yyval.pval)->next = npval(PV_WORD,(yylsp[-2]).first_line,(yylsp[-2]).last_line, (yylsp[-2]).first_column, (yylsp[-2]).last_column); 
					(yyval.pval)->next->u1.str = (yyvsp[-2].str); 
					(yyval.pval)->next->next = npval(PV_WORD,(yylsp[0]).first_line,(yylsp[0]).last_line, (yylsp[0]).first_column, (yylsp[0]).last_column); 
					(yyval.pval)->next->next->u1.str = (yyvsp[0].str); ;}
    break;

  case 96:
#line 353 "ael.y"
    {(yyval.pval)=npval(PV_WORD,(yylsp[-4]).first_line,(yylsp[-4]).last_line, (yylsp[-4]).first_column, (yylsp[-4]).last_column); 
					(yyval.pval)->u1.str = strdup("default"); (yyval.pval)->next = npval(PV_WORD,(yylsp[-2]).first_line,(yylsp[-2]).last_line, (yylsp[-2]).first_column, (yylsp[-2]).last_column); 
					(yyval.pval)->next->u1.str = (yyvsp[-2].str); 
					(yyval.pval)->next->next = npval(PV_WORD,(yylsp[0]).first_line,(yylsp[0]).last_line, (yylsp[0]).first_column, (yylsp[0]).last_column); 
					(yyval.pval)->next->next->u1.str = (yyvsp[0].str); ;}
    break;

  case 97:
#line 360 "ael.y"
    {(yyval.pval)=npval(PV_WORD,(yylsp[0]).first_line,(yylsp[0]).last_line, (yylsp[0]).first_column, (yylsp[0]).last_column); 
					(yyval.pval)->u1.str = (yyvsp[0].str); (yyval.pval)->next = npval(PV_WORD,(yylsp[0]).first_line,(yylsp[0]).last_line, (yylsp[0]).first_column, (yylsp[0]).last_column); 
					(yyval.pval)->next->u1.str = strdup("1");;}
    break;

  case 98:
#line 363 "ael.y"
    {(yyval.pval)=npval(PV_WORD,(yylsp[-2]).first_line,(yylsp[-2]).last_line, (yylsp[-2]).first_column, (yylsp[-2]).last_column); 
					(yyval.pval)->u1.str = (yyvsp[-2].str); (yyval.pval)->next = npval(PV_WORD,(yylsp[0]).first_line,(yylsp[0]).last_line, (yylsp[0]).first_column, (yylsp[0]).last_column); 
					(yyval.pval)->next->u1.str = (yyvsp[0].str);;}
    break;

  case 99:
#line 366 "ael.y"
    {(yyval.pval)=npval(PV_WORD,(yylsp[-4]).first_line,(yylsp[-4]).last_line, (yylsp[-4]).first_column, (yylsp[-4]).last_column); 
					(yyval.pval)->u1.str = (yyvsp[0].str); (yyval.pval)->next = npval(PV_WORD,(yylsp[-2]).first_line,(yylsp[-2]).last_line, (yylsp[-2]).first_column, (yylsp[-2]).last_column); 
					(yyval.pval)->next->u1.str = (yyvsp[-4].str); 
					(yyval.pval)->next->next = npval(PV_WORD,(yylsp[0]).first_line,(yylsp[0]).last_line, (yylsp[0]).first_column, (yylsp[0]).last_column); 
					(yyval.pval)->next->next->u1.str = (yyvsp[-2].str); ;}
    break;

  case 100:
#line 371 "ael.y"
    {(yyval.pval)=npval(PV_WORD,(yylsp[-2]).first_line,(yylsp[-2]).last_line, (yylsp[-2]).first_column, (yylsp[-2]).last_column); 
					(yyval.pval)->u1.str = (yyvsp[0].str); (yyval.pval)->next = npval(PV_WORD,(yylsp[0]).first_line,(yylsp[0]).last_line, (yylsp[0]).first_column, (yylsp[0]).last_column); 
					(yyval.pval)->next->u1.str = (yyvsp[-2].str); 
					(yyval.pval)->next->next = npval(PV_WORD,(yylsp[0]).first_line,(yylsp[0]).last_line, (yylsp[0]).first_column, (yylsp[0]).last_column); 
					(yyval.pval)->next->next->u1.str = strdup("1"); ;}
    break;

  case 101:
#line 376 "ael.y"
    {(yyval.pval)=npval(PV_WORD,(yylsp[-4]).first_line,(yylsp[-4]).last_line, (yylsp[-4]).first_column, (yylsp[-4]).last_column); 
					(yyval.pval)->u1.str = strdup("default"); (yyval.pval)->next = npval(PV_WORD,(yylsp[-2]).first_line,(yylsp[-2]).last_line, (yylsp[-2]).first_column, (yylsp[-2]).last_column); 
					(yyval.pval)->next->u1.str = (yyvsp[-4].str); 
					(yyval.pval)->next->next = npval(PV_WORD,(yylsp[0]).first_line,(yylsp[0]).last_line, (yylsp[0]).first_column, (yylsp[0]).last_column); 
					(yyval.pval)->next->next->u1.str = (yyvsp[-2].str); ;}
    break;

  case 102:
#line 381 "ael.y"
    {(yyval.pval)=npval(PV_WORD,(yylsp[-2]).first_line,(yylsp[-2]).last_line, (yylsp[-2]).first_column, (yylsp[-2]).last_column); 
					(yyval.pval)->u1.str = strdup("default"); (yyval.pval)->next = npval(PV_WORD,(yylsp[0]).first_line,(yylsp[0]).last_line, (yylsp[0]).first_column, (yylsp[0]).last_column); 
					(yyval.pval)->next->u1.str = (yyvsp[-2].str); 
					(yyval.pval)->next->next = npval(PV_WORD,(yylsp[0]).first_line,(yylsp[0]).last_line, (yylsp[0]).first_column, (yylsp[0]).last_column); 
					(yyval.pval)->next->next->u1.str = strdup("1"); ;}
    break;

  case 103:
#line 388 "ael.y"
    {reset_argcount(((struct parse_io *)parseio)->scanner);;}
    break;

  case 104:
#line 389 "ael.y"
    {(yyval.pval)= npval(PV_MACRO_CALL,(yylsp[-4]).first_line,(yylsp[-3]).last_line, (yylsp[-4]).first_column, (yylsp[-3]).last_column); 
			(yyval.pval)->u1.str = (yyvsp[-4].str); (yyval.pval)->u2.arglist = (yyvsp[-1].pval);;}
    break;

  case 105:
#line 391 "ael.y"
    {(yyval.pval)= npval(PV_MACRO_CALL,(yylsp[-2]).first_line,(yylsp[0]).last_line, (yylsp[-2]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.str = (yyvsp[-2].str); ;}
    break;

  case 106:
#line 394 "ael.y"
    {reset_argcount(((struct parse_io *)parseio)->scanner);;}
    break;

  case 107:
#line 394 "ael.y"
    {if (strcasecmp((yyvsp[-2].str),"goto") == 0) {
																							(yyval.pval)= npval(PV_GOTO,(yylsp[-2]).first_line,(yylsp[0]).last_line, (yylsp[-2]).first_column, (yylsp[0]).last_column); 
																							ast_log(LOG_WARNING, "==== File: %s, Line %d, Cols: %d-%d: Suggestion: Use the goto statement instead of the Goto() application call in AEL.\n", my_file, (yylsp[-2]).first_line, (yylsp[-2]).first_column, (yylsp[-2]).last_column );
																						} else
																							(yyval.pval)= npval(PV_APPLICATION_CALL,(yylsp[-2]).first_line,(yylsp[0]).last_line, (yylsp[-2]).first_column, (yylsp[0]).last_column); 
																						(yyval.pval)->u1.str = (yyvsp[-2].str); ;}
    break;

  case 108:
#line 402 "ael.y"
    {(yyval.pval) = (yyvsp[-2].pval);
 		if( (yyval.pval)->type == PV_GOTO )
			(yyval.pval)->u1.list = (yyvsp[-1].pval);
	 	else
			(yyval.pval)->u2.arglist = (yyvsp[-1].pval);
 		(yyval.pval)->endline = (yylsp[0]).last_line; (yyval.pval)->endcol = (yylsp[0]).last_column;;}
    break;

  case 109:
#line 408 "ael.y"
    {(yyval.pval)=(yyvsp[-1].pval);(yyval.pval)->endline = (yylsp[0]).last_line; (yyval.pval)->endcol = (yylsp[0]).last_column;;}
    break;

  case 110:
#line 411 "ael.y"
    { (yyval.pval)= npval(PV_WORD,(yylsp[0]).first_line,(yylsp[0]).last_line, (yylsp[0]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.str = (yyvsp[0].str);;}
    break;

  case 111:
#line 412 "ael.y"
    { (yyval.pval)= npval(PV_WORD,0/*@1.first_line*/,0/*@1.last_line*/,0/* @1.first_column*/, 0/*@1.last_column*/); (yyval.pval)->u1.str = strdup(""); ;}
    break;

  case 112:
#line 413 "ael.y"
    { pval *z = npval(PV_WORD,(yylsp[0]).first_line,(yylsp[0]).last_line, (yylsp[0]).first_column, (yylsp[0]).last_column); (yyval.pval) = (yyvsp[-2].pval); linku1((yyvsp[-2].pval),z); z->u1.str = (yyvsp[0].str);;}
    break;

  case 113:
#line 414 "ael.y"
    { pval *z = npval(PV_WORD,(yylsp[0]).first_line,(yylsp[0]).last_line, (yylsp[0]).first_column, (yylsp[0]).last_column); (yyval.pval) = (yyvsp[-1].pval); linku1((yyvsp[-1].pval),z); z->u1.str = strdup("");;}
    break;

  case 114:
#line 417 "ael.y"
    {(yyval.pval)=(yyvsp[0].pval);;}
    break;

  case 115:
#line 418 "ael.y"
    { if ( (yyvsp[-1].pval) && (yyvsp[0].pval) ) {(yyval.pval)=(yyvsp[-1].pval); linku1((yyval.pval),(yyvsp[0].pval));} 
						 else if ( (yyvsp[-1].pval) ) {(yyval.pval)=(yyvsp[-1].pval);}
						 else if ( (yyvsp[0].pval) ) {(yyval.pval)=(yyvsp[0].pval);} ;}
    break;

  case 116:
#line 423 "ael.y"
    {(yyval.pval) = npval(PV_CASE,(yylsp[-3]).first_line,(yylsp[-1]).last_line, (yylsp[-3]).first_column, (yylsp[-1]).last_column); (yyval.pval)->u1.str = (yyvsp[-2].str); (yyval.pval)->u2.statements = (yyvsp[0].pval);;}
    break;

  case 117:
#line 424 "ael.y"
    {(yyval.pval) = npval(PV_DEFAULT,(yylsp[-2]).first_line,(yylsp[0]).last_line, (yylsp[-2]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.str = 0; (yyval.pval)->u2.statements = (yyvsp[0].pval);;}
    break;

  case 118:
#line 425 "ael.y"
    {(yyval.pval) = npval(PV_PATTERN,(yylsp[-3]).first_line,(yylsp[-1]).last_line, (yylsp[-3]).first_column, (yylsp[-1]).last_column); (yyval.pval)->u1.str = (yyvsp[-2].str); (yyval.pval)->u2.statements = (yyvsp[0].pval);;}
    break;

  case 119:
#line 426 "ael.y"
    {(yyval.pval) = npval(PV_CASE,(yylsp[-2]).first_line,(yylsp[0]).last_line, (yylsp[-2]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.str = (yyvsp[-1].str);;}
    break;

  case 120:
#line 427 "ael.y"
    {(yyval.pval) = npval(PV_DEFAULT,(yylsp[-1]).first_line,(yylsp[0]).last_line, (yylsp[-1]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.str = 0;;}
    break;

  case 121:
#line 428 "ael.y"
    {(yyval.pval) = npval(PV_PATTERN,(yylsp[-2]).first_line,(yylsp[0]).last_line, (yylsp[-2]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.str = (yyvsp[-1].str);;}
    break;

  case 122:
#line 431 "ael.y"
    {(yyval.pval) = (yyvsp[0].pval);;}
    break;

  case 123:
#line 432 "ael.y"
    { if ( (yyvsp[-1].pval) && (yyvsp[0].pval) ) {(yyval.pval)=(yyvsp[-1].pval); linku1((yyval.pval),(yyvsp[0].pval));} 
						 else if ( (yyvsp[-1].pval) ) {(yyval.pval)=(yyvsp[-1].pval);}
						 else if ( (yyvsp[0].pval) ) {(yyval.pval)=(yyvsp[0].pval);} ;}
    break;

  case 124:
#line 437 "ael.y"
    {(yyval.pval)=(yyvsp[0].pval);;}
    break;

  case 125:
#line 438 "ael.y"
    {(yyval.pval)=npval(PV_CATCH,(yylsp[-4]).first_line,(yylsp[0]).last_line, (yylsp[-4]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.str = (yyvsp[-3].str); (yyval.pval)->u2.statements = (yyvsp[-1].pval);;}
    break;

  case 126:
#line 441 "ael.y"
    {(yyval.pval)= npval(PV_SWITCHES,(yylsp[-3]).first_line,(yylsp[0]).last_line, (yylsp[-3]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.list = (yyvsp[-1].pval); ;}
    break;

  case 127:
#line 442 "ael.y"
    {(yyval.pval)= npval(PV_SWITCHES,(yylsp[-2]).first_line,(yylsp[0]).last_line, (yylsp[-2]).first_column, (yylsp[0]).last_column);;}
    break;

  case 128:
#line 445 "ael.y"
    {(yyval.pval)= npval(PV_ESWITCHES,(yylsp[-3]).first_line,(yylsp[0]).last_line, (yylsp[-3]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.list = (yyvsp[-1].pval); ;}
    break;

  case 129:
#line 446 "ael.y"
    {(yyval.pval)= npval(PV_ESWITCHES,(yylsp[-2]).first_line,(yylsp[0]).last_line, (yylsp[-2]).first_column, (yylsp[0]).last_column); ;}
    break;

  case 130:
#line 449 "ael.y"
    {(yyval.pval)=npval(PV_WORD,(yylsp[-1]).first_line,(yylsp[0]).last_line, (yylsp[-1]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.str = (yyvsp[-1].str);;}
    break;

  case 131:
#line 450 "ael.y"
    {pval *z = npval(PV_WORD,(yylsp[-1]).first_line,(yylsp[0]).last_line, (yylsp[-1]).first_column, (yylsp[0]).last_column); (yyval.pval)=(yyvsp[-2].pval); z->u1.str = (yyvsp[-1].str); linku1((yyval.pval),z); ;}
    break;

  case 133:
#line 454 "ael.y"
    {(yyval.pval)=npval(PV_WORD,(yylsp[-1]).first_line,(yylsp[0]).last_line, (yylsp[-1]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.str = (yyvsp[-1].str);;}
    break;

  case 134:
#line 455 "ael.y"
    {
                    (yyval.pval)=npval(PV_WORD,(yylsp[-13]).first_line,(yylsp[-12]).last_line, (yylsp[-13]).first_column, (yylsp[-12]).last_column); 
                    (yyval.pval)->u1.str = (yyvsp[-13].str);
					(yyval.pval)->u2.arglist = npval(PV_WORD,(yylsp[-11]).first_line,(yylsp[-7]).last_line, (yylsp[-11]).first_column, (yylsp[-7]).last_column); 
					(yyval.pval)->u2.arglist->u1.str = (char*)malloc(strlen((yyvsp[-11].str))+strlen((yyvsp[-9].str))+strlen((yyvsp[-7].str))+4);
					strcpy((yyval.pval)->u2.arglist->u1.str,(yyvsp[-11].str));
					strcat((yyval.pval)->u2.arglist->u1.str,":");
					strcat((yyval.pval)->u2.arglist->u1.str,(yyvsp[-9].str));
					strcat((yyval.pval)->u2.arglist->u1.str,":");
					strcat((yyval.pval)->u2.arglist->u1.str,(yyvsp[-7].str));
					free((yyvsp[-11].str));
					free((yyvsp[-9].str));
					free((yyvsp[-7].str));
					(yyval.pval)->u2.arglist->next = npval(PV_WORD,(yylsp[-5]).first_line,(yylsp[-5]).last_line, (yylsp[-5]).first_column, (yylsp[-5]).last_column); 
					(yyval.pval)->u2.arglist->next->u1.str = (yyvsp[-5].str); 
					(yyval.pval)->u2.arglist->next->next = npval(PV_WORD,(yylsp[-3]).first_line,(yylsp[-3]).last_line, (yylsp[-3]).first_column, (yylsp[-3]).last_column); 
					(yyval.pval)->u2.arglist->next->next->u1.str = (yyvsp[-3].str); 
					(yyval.pval)->u2.arglist->next->next->next = npval(PV_WORD,(yylsp[-1]).first_line,(yylsp[-1]).last_line, (yylsp[-1]).first_column, (yylsp[-1]).last_column); 
					(yyval.pval)->u2.arglist->next->next->next->u1.str = (yyvsp[-1].str); 
					prev_word=0;
			;}
    break;

  case 135:
#line 476 "ael.y"
    {
                    (yyval.pval)=npval(PV_WORD,(yylsp[-9]).first_line,(yylsp[-8]).last_line, (yylsp[-9]).first_column, (yylsp[-8]).last_column); 
                    (yyval.pval)->u1.str = (yyvsp[-9].str);
					(yyval.pval)->u2.arglist = npval(PV_WORD,(yylsp[-7]).first_line,(yylsp[-7]).last_line, (yylsp[-7]).first_column, (yylsp[-7]).last_column); 
					(yyval.pval)->u2.arglist->u1.str = (yyvsp[-7].str);
					(yyval.pval)->u2.arglist->next = npval(PV_WORD,(yylsp[-5]).first_line,(yylsp[-5]).last_line, (yylsp[-5]).first_column, (yylsp[-5]).last_column); 
					(yyval.pval)->u2.arglist->next->u1.str = (yyvsp[-5].str); 
					(yyval.pval)->u2.arglist->next->next = npval(PV_WORD,(yylsp[-3]).first_line,(yylsp[-3]).last_line, (yylsp[-3]).first_column, (yylsp[-3]).last_column); 
					(yyval.pval)->u2.arglist->next->next->u1.str = (yyvsp[-3].str); 
					(yyval.pval)->u2.arglist->next->next->next = npval(PV_WORD,(yylsp[-1]).first_line,(yylsp[-1]).last_line, (yylsp[-1]).first_column, (yylsp[-1]).last_column); 
					(yyval.pval)->u2.arglist->next->next->next->u1.str = (yyvsp[-1].str); 
					prev_word=0;
			;}
    break;

  case 136:
#line 489 "ael.y"
    {pval *z = npval(PV_WORD,(yylsp[-1]).first_line,(yylsp[0]).last_line, (yylsp[-1]).first_column, (yylsp[0]).last_column); (yyval.pval)=(yyvsp[-2].pval); z->u1.str = (yyvsp[-1].str); linku1((yyval.pval),z); ;}
    break;

  case 137:
#line 490 "ael.y"
    {pval *z = npval(PV_WORD,(yylsp[-13]).first_line,(yylsp[-12]).last_line, (yylsp[-13]).first_column, (yylsp[-12]).last_column); 
					(yyval.pval)=(yyvsp[-14].pval); z->u1.str = (yyvsp[-13].str); linku1((yyval.pval),z);
					z->u2.arglist = npval(PV_WORD,(yylsp[-11]).first_line,(yylsp[-11]).last_line, (yylsp[-11]).first_column, (yylsp[-11]).last_column); 
					(yyval.pval)->u2.arglist->u1.str = (char*)malloc(strlen((yyvsp[-11].str))+strlen((yyvsp[-9].str))+strlen((yyvsp[-7].str))+4);
					strcpy((yyval.pval)->u2.arglist->u1.str,(yyvsp[-11].str));
					strcat((yyval.pval)->u2.arglist->u1.str,":");
					strcat((yyval.pval)->u2.arglist->u1.str,(yyvsp[-9].str));
					strcat((yyval.pval)->u2.arglist->u1.str,":");
					strcat((yyval.pval)->u2.arglist->u1.str,(yyvsp[-7].str));
					free((yyvsp[-11].str));
					free((yyvsp[-9].str));
					free((yyvsp[-7].str));
					z->u2.arglist->next = npval(PV_WORD,(yylsp[-5]).first_line,(yylsp[-5]).last_line, (yylsp[-5]).first_column, (yylsp[-5]).last_column); 
					z->u2.arglist->next->u1.str = (yyvsp[-5].str); 
					z->u2.arglist->next->next = npval(PV_WORD,(yylsp[-3]).first_line,(yylsp[-3]).last_line, (yylsp[-3]).first_column, (yylsp[-3]).last_column); 
					z->u2.arglist->next->next->u1.str = (yyvsp[-3].str); 
					z->u2.arglist->next->next->next = npval(PV_WORD,(yylsp[-1]).first_line,(yylsp[-1]).last_line, (yylsp[-1]).first_column, (yylsp[-1]).last_column); 
					z->u2.arglist->next->next->next->u1.str = (yyvsp[-1].str); 
					prev_word=0;
			;}
    break;

  case 138:
#line 511 "ael.y"
    {pval *z = npval(PV_WORD,(yylsp[-9]).first_line,(yylsp[-9]).last_line, (yylsp[-9]).first_column, (yylsp[-8]).last_column);
					(yyval.pval)=(yyvsp[-10].pval); z->u1.str = (yyvsp[-9].str); linku1((yyval.pval),z);
					z->u2.arglist = npval(PV_WORD,(yylsp[-7]).first_line,(yylsp[-7]).last_line, (yylsp[-7]).first_column, (yylsp[-7]).last_column);
					(yyval.pval)->u2.arglist->u1.str = (yyvsp[-7].str);
					z->u2.arglist->next = npval(PV_WORD,(yylsp[-5]).first_line,(yylsp[-5]).last_line, (yylsp[-5]).first_column, (yylsp[-5]).last_column);
					z->u2.arglist->next->u1.str = (yyvsp[-5].str);
					z->u2.arglist->next->next = npval(PV_WORD,(yylsp[-3]).first_line,(yylsp[-3]).last_line, (yylsp[-3]).first_column, (yylsp[-3]).last_column);
					z->u2.arglist->next->next->u1.str = (yyvsp[-3].str);
					z->u2.arglist->next->next->next = npval(PV_WORD,(yylsp[-1]).first_line,(yylsp[-1]).last_line, (yylsp[-1]).first_column, (yylsp[-1]).last_column);
					z->u2.arglist->next->next->next->u1.str = (yyvsp[-1].str);
					prev_word=0;
			;}
    break;

  case 140:
#line 526 "ael.y"
    { (yyval.str) = (yyvsp[0].str);;}
    break;

  case 141:
#line 527 "ael.y"
    {(yyval.str)=strdup("default");;}
    break;

  case 142:
#line 530 "ael.y"
    {(yyval.pval)= npval(PV_INCLUDES,(yylsp[-3]).first_line,(yylsp[0]).last_line, (yylsp[-3]).first_column, (yylsp[0]).last_column); (yyval.pval)->u1.list = (yyvsp[-1].pval);;}
    break;

  case 143:
#line 531 "ael.y"
    {(yyval.pval)= npval(PV_INCLUDES,(yylsp[-2]).first_line,(yylsp[0]).last_line, (yylsp[-2]).first_column, (yylsp[0]).last_column);;}
    break;


      default: break;
    }

/* Line 1126 of yacc.c.  */
#line 2485 "ael.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;
  yylsp -= yylen;

  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  int yytype = YYTRANSLATE (yychar);
	  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
	  YYSIZE_T yysize = yysize0;
	  YYSIZE_T yysize1;
	  int yysize_overflow = 0;
	  char *yymsg = 0;
#	  define YYERROR_VERBOSE_ARGS_MAXIMUM 5
	  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
	  int yyx;

#if 0
	  /* This is so xgettext sees the translatable formats that are
	     constructed on the fly.  */
	  YY_("syntax error, unexpected %s");
	  YY_("syntax error, unexpected %s, expecting %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s or %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
#endif
	  char *yyfmt;
	  char const *yyf;
	  static char const yyunexpected[] = "syntax error, unexpected %s";
	  static char const yyexpecting[] = ", expecting %s";
	  static char const yyor[] = " or %s";
	  char yyformat[sizeof yyunexpected
			+ sizeof yyexpecting - 1
			+ ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
			   * (sizeof yyor - 1))];
	  char const *yyprefix = yyexpecting;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 1;

	  yyarg[0] = yytname[yytype];
	  yyfmt = yystpcpy (yyformat, yyunexpected);

	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
		  {
		    yycount = 1;
		    yysize = yysize0;
		    yyformat[sizeof yyunexpected - 1] = '\0';
		    break;
		  }
		yyarg[yycount++] = yytname[yyx];
		yysize1 = yysize + yytnamerr (0, yytname[yyx]);
		yysize_overflow |= yysize1 < yysize;
		yysize = yysize1;
		yyfmt = yystpcpy (yyfmt, yyprefix);
		yyprefix = yyor;
	      }

	  yyf = YY_(yyformat);
	  yysize1 = yysize + yystrlen (yyf);
	  yysize_overflow |= yysize1 < yysize;
	  yysize = yysize1;

	  if (!yysize_overflow && yysize <= YYSTACK_ALLOC_MAXIMUM)
	    yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg)
	    {
	      /* Avoid sprintf, as that infringes on the user's name space.
		 Don't have undefined behavior even if the translation
		 produced a string with the wrong number of "%s"s.  */
	      char *yyp = yymsg;
	      int yyi = 0;
	      while ((*yyp = *yyf))
		{
		  if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		    {
		      yyp += yytnamerr (yyp, yyarg[yyi++]);
		      yyf += 2;
		    }
		  else
		    {
		      yyp++;
		      yyf++;
		    }
		}
	      yyerror (&yylloc, NULL, yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    {
	      yyerror (&yylloc, NULL, YY_("syntax error"));
	      goto yyexhaustedlab;
	    }
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror (&yylloc, NULL, YY_("syntax error"));
    }

  yyerror_range[0] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
        }
      else
	{
	  yydestruct ("Error: discarding", yytoken, &yylval, &yylloc);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (0)
     goto yyerrorlab;

  yyerror_range[0] = yylsp[1-yylen];
  yylsp -= yylen;
  yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[0] = *yylsp;
      yydestruct ("Error: popping", yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;

  yyerror_range[1] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the look-ahead.  YYLOC is available though. */
  YYLLOC_DEFAULT (yyloc, yyerror_range - 1, 2);
  *++yylsp = yyloc;

  /* Shift the error token. */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, NULL, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval, &yylloc);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK;
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 535 "ael.y"


static char *token_equivs1[] = 
{
	"AMPER",
	"AT",
	"BAR",
	"COLON",
	"COMMA",
	"EQ",
	"EXTENMARK",
	"KW_BREAK", 
	"KW_CASE", 
	"KW_CATCH", 
	"KW_CONTEXT",
	"KW_CONTINUE", 
	"KW_DEFAULT", 
	"KW_ELSE",
	"KW_ESWITCHES",
	"KW_FOR", 
	"KW_GLOBALS",
	"KW_GOTO",
	"KW_HINT",
	"KW_IFTIME",
	"KW_IF",
	"KW_IGNOREPAT",
	"KW_INCLUDES"
	"KW_JUMP",
	"KW_MACRO",
	"KW_PATTERN", 
	"KW_REGEXTEN", 
	"KW_RETURN", 
	"KW_SWITCHES", 
	"KW_SWITCH",
	"KW_WHILE", 
	"LC",
	"LP",
	"RC",
	"RP",
	"SEMI",
};

static char *token_equivs2[] = 
{
	"&",
	"@",
	"|",
	":",
	",",
	"=",
	"=>",
	"break", 
	"case", 
	"catch", 
	"context",
	"continue", 
	"default", 
	"else",
	"eswitches",
	"for", 
	"globals",
	"goto",
	"hint",
	"ifTime",
	"if",
	"ignorepat",
	"includes"
	"jump",
	"macro",
	"pattern", 
	"regexten", 
	"return", 
	"switches", 
	"switch",
	"while", 
	"{",
	"(",
	"}",
	")",
	";",
};


static char *ael_token_subst(char *mess)
{
	/* calc a length, malloc, fill, and return; yyerror had better free it! */
	int len=0,i;
	char *p;
	char *res, *s,*t;
	int token_equivs_entries = sizeof(token_equivs1)/sizeof(char*);

	for (p=mess; *p; p++) {
		for (i=0; i<token_equivs_entries; i++) {
			if ( strncmp(p,token_equivs1[i],strlen(token_equivs1[i])) == 0 )
			{
				len+=strlen(token_equivs2[i])+2;
				p += strlen(token_equivs1[i])-1;
				break;
			}
		}
		len++;
	}
	res = (char*)malloc(len+1);
	res[0] = 0;
	s = res;
	for (p=mess; *p;) {
		int found = 0;
		for (i=0; i<token_equivs_entries; i++) {
			if ( strncmp(p,token_equivs1[i],strlen(token_equivs1[i])) == 0 ) {
				*s++ = '\'';
				for (t=token_equivs2[i]; *t;) {
					*s++ = *t++;
				}
				*s++ = '\'';
				p += strlen(token_equivs1[i]);
				found = 1;
				break;
			}
		}
		if( !found )
			*s++ = *p++;
	}
	*s++ = 0;
	return res;
}

void yyerror(YYLTYPE *locp, void *nothing,  char const *s)
{
	char *s2 = ael_token_subst((char *)s);
	if (locp->first_line == locp->last_line) {
		ast_log(LOG_ERROR, "==== File: %s, Line %d, Cols: %d-%d: Error: %s\n", my_file, locp->first_line, locp->first_column, locp->last_column, s2);
	} else {
		ast_log(LOG_ERROR, "==== File: %s, Line %d Col %d  to Line %d Col %d: Error: %s\n", my_file, locp->first_line, locp->first_column, locp->last_line, locp->last_column, s2);
	}
	free(s2);
	
	ael_errcnt++;
}

struct pval *npval(pvaltype type,int first_line, int last_line, int first_column, int last_column)
{
	extern char *my_file;
	pval *z = (pval *)calloc(sizeof(struct pval),1);
	z->type = type;
	z->startline = first_line;
	z->endline = last_line;
	z->startcol = first_column;
	z->endcol = last_column;
	z->filename = strdup(my_file);
	return z;
}

void linku1(pval *head, pval *tail)
{
	if (!head->next) {
		head->next = tail;
		head->u1_last = tail;
	} else {
		head->u1_last->next = tail;
		head->u1_last = tail;
	}
}


